

import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.ExcludeSuperclassListeners;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.PostLoad;
import javax.persistence.PostPersist;
import javax.persistence.PostUpdate;
import javax.persistence.Transient;

@Entity
@Inheritance(strategy=InheritanceType.JOINED)
@DiscriminatorColumn(name="EMP_TYPE", discriminatorType=DiscriminatorType.INTEGER)
@ExcludeSuperclassListeners
//@EntityListeners({EmployeeDebugListener.class})
public abstract class Employee {
    @Id private int id;
    private String name;
    @Transient private long syncTime;

    @PostPersist 
    @PostUpdate
    @PostLoad 
    private void resetSyncTime() {
        syncTime = System.currentTimeMillis(); 
        System.out.println("Employee.resetSyncTime called on employee id: " + getId());
    }

    public long getCachedAge() {
        return System.currentTimeMillis() - syncTime; 
    }

    public int getId() {
        return id;
    }
    
    public void setId(int id) {
        this.id = id;
    }

    public String toString() {
        return "Employee id: " + getId() ;
    }
}
@Entity
@EntityListeners(EmployeeDebugListener.class)
class EmployeePartTime extends Employee{
  
  
}